# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""

#Marcin Śliwa
import os
import Mapa_PU
from PyQt5.QtGui import * 
from PyQt5.QtCore import * 

from PyQt5 import QtWidgets, uic
from Mapa_PU.kontroler import komunikaty

FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'etykietuj_obiekty_liniowe.ui'))

class EtykietujObiektyLinioweOkno(QtWidgets.QMainWindow,FORM_CLASS):
    def __init__(self,parent=None):
        """Konstruktor"""
        super(EtykietujObiektyLinioweOkno,self).__init__(parent)
        self.setupUi(self)
      
        #self.setWindowFlags( Qt.Dialog | Qt.WindowTitleHint )
        self.setWindowFlags( Qt.Dialog)
        self.__KODY=  ('DROGI L', u'KANAŁ', 'POTOK', 'ROWY', 'RZEKA', 'L ENERG', 'L TELEK', 'RUROC N', 'RUROC P', u'PAS PPOŻ', u'WAŁ OCHR', 'PAS GRAN', 'LINIE')
        self.kodObiektu.addItems(self.__KODY)
        #QObject.connect(self.etykietujPrzycisk, SIGNAL("clicked()"),self.__metodaPrzycisku)
        self.etykietujPrzycisk.clicked.connect(self.__metodaPrzycisku)
        self.startEdycji()
        self.powiadomienie.setStyleSheet("font-weight: bold; color: green")
        self.setWindowIcon(QIcon('%s\\ikony\\Logo_BULiGL.ico' % Mapa_PU.upul_modul.root))
       
        self.kodObiektu.currentIndexChanged.connect(self.__zmianaKodu)
        self.sbSzerokosc.valueChanged.connect(self.__zmianaSzerokosci)
        self.__aktualizuj_dane()
       
    def closeEvent(self, evnt):
        """Zdarzenie zamknięcia nadpisane""" 
        self.wypiszKomunikat('')
        self.zamknij()
    
    def wypiszKomunikat(self,komunikat):
        """Wypisuje komunikat na pasku"""
        self.powiadomienie.setText(komunikat)
     
    def metoda(self,kod,szerokosc):
        pass
    
    def zamknij(self):
        pass
    
    def aktualizujWartosci(self,kod,szerokosc):
        pass
 
        
    def startEdycji(self):
        self.wypiszKomunikat(u"Proszę ustawić wartości i wybrać 'Etykietuj'")
        self.etykietujPrzycisk.setEnabled(True)
    
    def __metodaPrzycisku(self):
        """Delegat metody przycisku"""
        try:
            self.wypiszKomunikat(u'Proszę wybrać obiekt liniowy na mapie')
            self.etykietujPrzycisk.setEnabled(False)
            self.kod=self.kodObiektu.currentText()
            self.szerokosc=self.sbSzerokosc.value()
            self.metoda(self.kod,self.szerokosc)
        except Exception as e:
            komunikaty.blad_systemowy(e)
            
    def __zmianaKodu(self):
        """Reakcja na zmiane kodu"""
        try:
            self.kod=self.kodObiektu.currentText()
            self.aktualizujWartosci(self.kod, self.szerokosc)
        except Exception as e:
            komunikaty.blad_systemowy(e)
            
    def __zmianaSzerokosci(self,wartosc):
        """reakcja na zmiane szerokosci"""
        try:
            self.szerokosc=wartosc
            self.aktualizujWartosci(self.kod, self.szerokosc)
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def __aktualizuj_dane(self):
        try:
            self.kod=self.kodObiektu.currentText()
            self.szerokosc=self.sbSzerokosc.value()
            
        except Exception as e:
            komunikaty.blad_systemowy(e)